VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIImageList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017
Private Const ERR_BASE As Long = 40670

Private Const CLSID_ImageList As String = _
    "{7C476BA2-02B1-48f4-8048-B24619DDC058}"
    
Private Const IID_IImageList As String = _
    "{46EB5926-582E-4017-9FDF-E8998DAA0950}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Add
    vtb_ReplaceIcon
    vtb_SetOverlayImage
    vtb_Replace
    vtb_AddMasked
    vtb_Draw
    vtb_Remove
    vtb_GetIcon
    vtb_GetImageInfo
    vtb_Copy
    vtb_Merge
    vtb_Clone
    vtb_GetImageRect
    vtb_GetIconSize
    vtb_SetIconSize
    vtb_GetImageCount
    vtb_SetImageCount
    vtb_SetBkColor
    vtb_GetBkColor
    vtb_BeginDrag
    vtb_EndDrag
    vtb_DragEnter
    vtb_DragLeave
    vtb_DragMove
    vtb_SetDragCursorImage
    vtb_DragShowNolock
    vtb_GetDragImage
    vtb_GetItemFlags
    vtb_GetOverlayImage
End Enum

Public Function GetIcon(ByVal i As Long, ByVal flags As Long) As Long
    
    Dim lRet As Long
    Dim picon As Long
    Dim ppicon As Long
    
    ppicon = VarPtr(picon)
    
    If x_OleInvoke(vtb_GetIcon, i, flags, ppicon) Then

        lRet = picon

    End If

    GetIcon = lRet
    
End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)
    
    m_Interface.RaiseErrors = Raise
    
End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_ImageList, _
            IID_IImageList)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIImageList", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub


