Attribute VB_Name = "modFolderTreeView"
Option Explicit

Private Const S_OK As Long = 0&
Private Const MAX_PATH As Long = 260&

' TreeView-Messages
Private Const TV_FIRST As Long = &H1100
Private Const TVM_SETITEMHEIGHT As Long = (TV_FIRST + 27)

' Interface-IDs
Private Const IID_IShellIcon As String = "{000214E5-0000-0000-C000-000000000046}"
Private Const IID_IShellFolder2 As String = "{93F2F68C-1D1B-11D3-A30E-00C04F79ABD1}"
Private Const IID_IImageList As String = "{46EB5926-582E-4017-9FDF-E8998DAA0950}"
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"

' FileAttribute
Private Const FILE_ATTRIBUTE_READONLY As Long = &H1&
Private Const FILE_ATTRIBUTE_HIDDEN As Long = &H2&
Private Const FILE_ATTRIBUTE_SYSTEM As Long = &H4&
Private Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10&
Private Const FILE_ATTRIBUTE_ARCHIVE As Long = &H20&
Private Const FILE_ATTRIBUTE_DEVICE As Long = &H40&
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80&
Private Const FILE_ATTRIBUTE_TEMPORARY As Long = &H100&
Private Const FILE_ATTRIBUTE_REPARSE_POINT As Long = &H400&
Private Const FILE_ATTRIBUTE_COMPRESSED As Long = &H800&
Private Const FILE_ATTRIBUTE_ENCRYPTED As Long = &H4000&
Private Const FILE_ATTRIBUTE_VIRTUAL As Long = &H10000

' IImageList
Private Const CLR_NONE = &HFFFFFFFF
Private Const CLR_DEFAULT = &HFF000000
Private Const SHIL_LARGE = &H0
Private Const SHIL_SMALL = &H1
Private Const SHIL_EXTRALARGE = &H2
Private Const SHIL_SYSSMALL = &H3
Private Const SHIL_JUMBO = &H4
Private Const SHIL_LAST = &H4

' GetDriveType
Private Const DRIVE_UNKNOWN As Long = 0
Private Const DRIVE_REMOVABLE As Long = 2
Private Const DRIVE_NO_ROOT_DIR As Long = 1
Private Const DRIVE_FIXED As Long = 3
Private Const DRIVE_REMOTE As Long = 4
Private Const DRIVE_CDROM As Long = 5
Private Const DRIVE_RAMDISK As Long = 6

' SHGetStockIconInfo uFlag
Private Const SHGSI_ICONLOCATION = &H0
Private Const SHGSI_ICON = &H100
Private Const SHGSI_SYSICONINDEX = &H4000
Private Const SHGSI_LINKOVERLAY = &H8000
Private Const SHGSI_SELECTED = &H10000
Private Const SHGSI_LARGEICON = &H0
Private Const SHGSI_SMALLICON = &H1
Private Const SHGSI_SHELLICONSIZE = &H4

' SHGetStockIconInfo siid
Private Enum SHSTOCKICONID
    SIID_DOCNOASSOC = 0
    SIID_DOCASSOC = 1
    SIID_APPLICATION = 2
    SIID_FOLDER = 3
    SIID_FOLDEROPEN = 4
    SIID_DRIVE525 = 5
    SIID_DRIVE35 = 6
    SIID_DRIVEREMOVE = 7
    SIID_DRIVEFIXED = 8
    SIID_DRIVENET = 9
    SIID_DRIVENETDISABLED = 10
    SIID_DRIVECD = 11
    SIID_DRIVERAM = 12
    SIID_WORLD = 13
    SIID_SERVER = 15
    SIID_PRINTER = 16
    SIID_MYNETWORK = 17
    SIID_FIND = 22
    SIID_HELP = 23
    SIID_SHARE = 28
    SIID_LINK = 29
    SIID_SLOWFILE = 30
    SIID_RECYCLER = 31
    SIID_RECYCLERFULL = 32
    SIID_MEDIACDAUDIO = 40
    SIID_LOCK = 47
    SIID_AUTOLIST = 49
    SIID_PRINTERNET = 50
    SIID_SERVERSHARE = 51
    SIID_PRINTERFAX = 52
    SIID_PRINTERFAXNET = 53
    SIID_PRINTERFILE = 54
    SIID_STACK = 55
    SIID_MEDIASVCD = 56
    SIID_STUFFEDFOLDER = 57
    SIID_DRIVEUNKNOWN = 58
    SIID_DRIVEDVD = 59
    SIID_MEDIADVD = 60
    SIID_MEDIADVDRAM = 61
    SIID_MEDIADVDRW = 62
    SIID_MEDIADVDR = 63
    SIID_MEDIADVDROM = 64
    SIID_MEDIACDAUDIOPLUS = 65
    SIID_MEDIACDRW = 66
    SIID_MEDIACDR = 67
    SIID_MEDIACDBURN = 68
    SIID_MEDIABLANKCD = 69
    SIID_MEDIACDROM = 70
    SIID_AUDIOFILES = 71
    SIID_IMAGEFILES = 72
    SIID_VIDEOFILES = 73
    SIID_MIXEDFILES = 74
    SIID_FOLDERBACK = 75
    SIID_FOLDERFRONT = 76
    SIID_SHIELD = 77
    SIID_WARNING = 78
    SIID_INFO = 79
    SIID_ERROR = 80
    SIID_KEY = 81
    SIID_SOFTWARE = 82
    SIID_RENAME = 83
    SIID_DELETE = 84
    SIID_MEDIAAUDIODVD = 85
    SIID_MEDIAMOVIEDVD = 86
    SIID_MEDIAENHANCEDCD = 87
    SIID_MEDIAENHANCEDDVD = 88
    SIID_MEDIAHDDVD = 89
    SIID_MEDIABLURAY = 90
    SIID_MEDIAVCD = 91
    SIID_MEDIADVDPLUSR = 92
    SIID_MEDIADVDPLUSRW = 93
    SIID_DESKTOPPC = 94
    SIID_MOBILEPC = 95
    SIID_USERS = 96
    SIID_MEDIASMARTMEDIA = 97
    SIID_MEDIACOMPACTFLASH = 98
    SIID_DEVICECELLPHONE = 99
    SIID_DEVICECAMERA = 100
    SIID_DEVICEVIDEOCAMERA = 101
    SIID_DEVICEAUDIOPLAYER = 102
    SIID_NETWORKCONNECT = 103
    SIID_INTERNET = 104
    SIID_ZIPFILE = 105
    SIID_SETTINGS = 106
    SIID_DRIVEHDDVD = 132
    SIID_DRIVEBD = 133
    SIID_MEDIAHDDVDROM = 134
    SIID_MEDIAHDDVDR = 135
    SIID_MEDIAHDDVDRAM = 136
    SIID_MEDIABDROM = 137
    SIID_MEDIABDR = 138
    SIID_MEDIABDRE = 139
    SIID_CLUSTEREDDRIVE = 140
    SIID_MAX_ICONS = 175
End Enum

' IShellFolder.EnumObjects
Public Enum SHCONTF
    SHCONTF_CHECKING_FOR_CHILDREN = &H10
    SHCONTF_FOLDERS = &H20
    SHCONTF_NONFOLDERS = &H40
    SHCONTF_INCLUDEHIDDEN = &H80
    SHCONTF_INIT_ON_FIRST_NEXT = &H100
    SHCONTF_NETPRINTERSRCH = &H200
    SHCONTF_SHAREABLE = &H400
    SHCONTF_STORAGE = &H800
    SHCONTF_NAVIGATION_ENUM = &H1000
    SHCONTF_FASTITEMS = &H2000
    SHCONTF_FLATLIST = &H4000
    SHCONTF_ENABLE_ASYNC = &H8000
    SHCONTF_INCLUDESUPERHIDDEN = &H10000
End Enum

' FindFirstFileEx
Private Enum FINDEX_INFO_LEVELS
    FindExInfoStandard = 0
    FindExInfoBasic = 1
    FindExInfoMaxInfoLevel = 2
End Enum

' FindFirstFileEx
Private Enum FINDEX_SEARCH_OPS
    FindExSearchNameMatch = 0
    FindExSearchLimitToDirectories = 1
    FindExSearchLimitToDevices = 2
End Enum

' FindFirstFileEx
Private Enum FINDEX_FIRST
    FIND_FIRST_EX_CASE_SENSITIVE = 1
    FIND_FIRST_EX_LARGE_FETCH = 2
End Enum

' SHELLDETAILS.str
Private Type STRRET
    uType As Long
    cbStr(0 To MAX_PATH - 1) As Byte
End Type

' IShellFolder2.GetDetailsOf
Private Type SHELLDETAILS
    fmt As Long
    cxChar As Long
    str As STRRET
End Type

' OleCreatePictureIndirect
Private Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

' SHGetStockIconInfo
Private Type SHSTOCKICONINFO
    cbSize As Long
    hIcon As Long
    iSysImageIndex As Long
    iIcon As Long
    szPath As String * MAX_PATH
End Type

' WIN32_FIND_DATA
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

' FindFirstFileEx
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Public Type Folder
    ShellName As String
    ShellPath As String
    ShellIconIndex As Long
End Type

' **************** Kernel32.dll ****************
Private Declare Function GetDriveTypeA Lib "kernel32.dll" ( _
                         ByVal nDrive As String) As Long

Private Declare Function QueryDosDevice Lib "kernel32.dll" _
                         Alias "QueryDosDeviceA" ( _
                         ByVal lpDeviceName As String, _
                         ByVal lpTargetPath As String, _
                         ByVal ucchMax As Long) As Long

Private Declare Function FindFirstFileExW Lib "kernel32.dll" ( _
                         ByVal lpFileName As Long, _
                         ByVal fInfoLevelId As FINDEX_INFO_LEVELS, _
                         ByRef lpFindFileData As WIN32_FIND_DATA, _
                         ByVal fSearchOp As FINDEX_SEARCH_OPS, _
                         ByRef lpSearchFilter As Long, _
                         ByVal dwAdditionalFlags As FINDEX_FIRST) As Long

Private Declare Function FindNextFileW Lib "kernel32" ( _
                         ByVal hFindFile As Long, _
                         ByRef lpFindFileData As WIN32_FIND_DATA) As Long

Private Declare Function FindClose Lib "kernel32" ( _
                         ByVal hFindFile As Long) As Long

Private Declare Function GetFileAttributes Lib "kernel32.dll" _
                         Alias "GetFileAttributesA" ( _
                         ByVal lpFileName As String) As Long

' **************** Shell32.dll ****************
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" _
                         Alias "SHGetPathFromIDListA" ( _
                         ByVal pidl As Long, _
                         ByVal pszPath As String) As Long

Private Declare Function SHGetImageList Lib "shell32" ( _
                         ByVal IImageList As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

Private Declare Function SHGetStockIconInfo Lib "shell32" ( _
                         ByVal siid As SHSTOCKICONID, _
                         ByVal uFlags As Long, _
                         ByRef psii As SHSTOCKICONINFO) As Long

Private Declare Function ILCombine Lib "shell32" ( _
                         ByVal pidl1 As Long, _
                         ByVal pidl2 As Long) As Long

' **************** Shlwapi.dll ****************
Private Declare Function StrRetToStrA Lib "shlwapi" ( _
                         ByVal pstr As Long, _
                         ByVal pidl As Long, _
                         ByRef ppszName As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)

' **************** Oleaut32.dll ****************
Private Declare Function SysAllocString Lib "oleaut32" ( _
                         ByVal psz As Long) As String

Private Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByVal riid As Long, _
                         ByVal fOwn As Boolean, _
                         ByRef lplpvObj As Object) As Long

' **************** User32.dll ****************
Private Declare Function DestroyIcon Lib "user32.dll" ( _
                         ByVal hIcon As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" _
                         Alias "SendMessageW" ( _
                         ByVal hwnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long

Private Declare Function LockWindowUpdate Lib "user32" ( _
                         ByVal hwndLock As Long) As Long

Public Function FillTreeView(ByVal sRootFolder As String, ByVal flags As SHCONTF, _
    ByVal oTV As TreeView) As Node

    Dim xNode As Node
    Dim lAttr As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim lIconIndex As Long
    Dim hIcon As Long
    Dim pIImageList As Long
    Dim sDriveLetter As String
    Dim lQDDRet As Long
    Dim sQDDRet As String
    Dim bRootIsDrive As Boolean
    Dim tFolders() As Folder
    Dim oIL As ImageList
    Dim xIcon As ListImage
    Dim SHSID As SHSTOCKICONID
    Dim SHSII As SHSTOCKICONINFO

    bRootIsDrive = False

    Call SendMessage(oTV.hwnd, TVM_SETITEMHEIGHT, 18&, 0&)

    If Len(sRootFolder) = 3 Then
        If Right$(sRootFolder, 2) = ":\" Then

            sDriveLetter = Mid$(sRootFolder, 1, 2)

            bRootIsDrive = True

        End If
    End If

    If Len(sRootFolder) = 2 Then
        If Right$(sRootFolder, 1) = ":" Then

            sRootFolder = sRootFolder & "\"
            sDriveLetter = Mid$(sRootFolder, 1, 2)

            bRootIsDrive = True

        End If
    End If

    ' DummyNode entfernen falls vorhanden
    If NodeExists(sRootFolder & "\DummyNode", oTV) = True Then

        Call oTV.Nodes.Remove(sRootFolder & "\DummyNode")

    End If

    ' Pointer auf die SystemImageList holen, 16px x 16px
    If SHGetImageList(SHIL_SMALL, IID2Long(IID_IImageList), pIImageList) = S_OK Then

        ' SystemImageList initialisieren
        Dim IImageList As New clsIImageList
        Call IImageList.Initialize(pIImageList)
        Call IImageList.RaiseError(False)

        ' eigene ImageList
        Set oIL = oTV.ImageList

        SHSII.cbSize = LenB(SHSII)

        ' OverlayIcon in die ImageList laden wenn nicht vorhanden
        If IconExists("Overlay_LINK", oIL) = False Then

            Call SHGetStockIconInfo(SIID_LINK, SHGSI_ICON Or SHGSI_SMALLICON, SHSII)

            Set xIcon = oIL.ListImages.Add(, "Overlay_LINK", Handle2IPicture( _
                SHSII.hIcon, vbPicTypeIcon))

            Call DestroyIcon(SHSII.hIcon)

        End If

        ' OverlayIcon in die ImageList laden wenn nicht vorhanden
        If IconExists("Overlay_SHARE", oIL) = False Then

            Call SHGetStockIconInfo(SIID_SHARE, SHGSI_ICON Or SHGSI_SMALLICON, _
                SHSII)

            Set xIcon = oIL.ListImages.Add(, "Overlay_SHARE", Handle2IPicture( _
                SHSII.hIcon, vbPicTypeIcon))

            Call DestroyIcon(SHSII.hIcon)

        End If

        ' OverlayIcon in die ImageList laden wenn nicht vorhanden
        If IconExists("Overlay_SLOWFILE", oIL) = False Then

            Call SHGetStockIconInfo(SIID_SLOWFILE, SHGSI_ICON Or SHGSI_SMALLICON, _
                SHSII)

            Set xIcon = oIL.ListImages.Add(, "Overlay_SLOWFILE", Handle2IPicture( _
                SHSII.hIcon, vbPicTypeIcon))

            Call DestroyIcon(SHSII.hIcon)

        End If

        With oTV.Nodes

            ' wenn der Node nicht existiert
            If NodeExists(sRootFolder, oTV) = False Then

                ' ist es ein Laufwerk
                If bRootIsDrive = True Then

                    ' Laufwerkstyp ermitteln
                    lIconIndex = GetDriveType(sRootFolder)

                    ' wenn das LaufwerksIcon noch nicht in der ImageList existiert
                    If IconExists("Drive" & CStr(lIconIndex), oIL) = False Then

                        ' nach laufwerkstyp selektieren
                        Select Case lIconIndex

                        Case DRIVE_UNKNOWN
                            SHSID = SIID_DRIVEUNKNOWN

                        Case DRIVE_REMOVABLE

                            ' DOS-Bezeichnung des Laufwerks ermitteln
                            sQDDRet = String$(MAX_PATH, 0)
                            lQDDRet = QueryDosDevice(sDriveLetter, sQDDRet, _
                                MAX_PATH)

                            If lQDDRet <> 0 Then

                                sQDDRet = CutNull(sQDDRet)

                            End If

                            If InStr(1, sQDDRet, "\Harddisk", vbTextCompare) Then

                                SHSID = SIID_DRIVEREMOVE

                            ElseIf InStr(1, sQDDRet, "\Floppy", vbTextCompare) Then

                                SHSID = SIID_DRIVE35

                            Else

                                SHSID = SIID_DRIVEREMOVE

                            End If

                        Case DRIVE_NO_ROOT_DIR
                            SHSID = SIID_DRIVEUNKNOWN

                        Case DRIVE_FIXED
                            SHSID = SIID_DRIVEFIXED

                        Case DRIVE_REMOTE
                            SHSID = SIID_DRIVENET

                        Case DRIVE_CDROM
                            SHSID = SIID_DRIVECD

                        Case DRIVE_RAMDISK
                            SHSID = SIID_DRIVERAM

                        Case Else
                            SHSID = SIID_DRIVEUNKNOWN

                        End Select

                        ' entsprechendes Laufwerksicon laden
                        SHSII.cbSize = LenB(SHSII)
                        Call SHGetStockIconInfo(SHSID, SHGSI_ICON Or _
                            SHGSI_SMALLICON, SHSII)

                        hIcon = SHSII.hIcon

                        ' und der ImageList hinzufgen
                        Set xIcon = oIL.ListImages.Add(, "Drive" & CStr( _
                            lIconIndex), Handle2IPicture(hIcon, vbPicTypeIcon))

                        ' Index des Icons in der ImageList
                        lIconIndex = xIcon.Index

                        Call DestroyIcon(hIcon)

                    Else

                        ' Index des Icons in der ImageList
                        lIconIndex = oIL.ListImages("Drive" & CStr( _
                            lIconIndex)).Index

                    End If

                Else

                    ' Index des Icons in der SystemImageList ermitteln
                    lIconIndex = GetIconIndex(sRootFolder)

                    ' Attribute des Ordners ermitteln
                    lAttr = GetFileAttributes(sRootFolder)

                    ' existiert ein entsprechendes Icon noch nicht in der ImageList
                    If IconExists("Icon" & CStr(lIconIndex), oIL) = False Then

                        ' Icon aus der SystemImageList laden
                        hIcon = IImageList.GetIcon(lIconIndex, CLR_DEFAULT)

                        ' und der ImageList hinzufgen
                        Set xIcon = oIL.ListImages.Add(, "Icon" & CStr( _
                            lIconIndex), Handle2IPicture(hIcon, vbPicTypeIcon))

                        ' Index des Icons in der ImageList
                        lIconIndex = xIcon.Index

                        Call DestroyIcon(hIcon)



                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_LINK" & CStr(lIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_LINK" & CStr(lIconIndex), _
                                oIL.Overlay("Icon" & CStr(lIconIndex), "Overlay_LINK"))

                        End If

                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_SHARE" & CStr(lIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_SHARE" & CStr(lIconIndex), _
                                oIL.Overlay("Icon" & CStr(lIconIndex), "Overlay_SHARE"))

                        End If

                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_SLOWFILE" & CStr(lIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_SLOWFILE" & _
                                CStr(lIconIndex), oIL.Overlay("Icon" & CStr(lIconIndex), _
                                "Overlay_SLOWFILE"))

                        End If

                        ' hat der Ordner das Attribut REPARSE_POINT
                        If (lAttr And FILE_ATTRIBUTE_REPARSE_POINT) = _
                            FILE_ATTRIBUTE_REPARSE_POINT Then

                            ' Index zu diesen Icon mit Overlayicon ermitteln
                            lIconIndex = oIL.ListImages("Icon_LINK" & CStr(lIconIndex)).Index

                        End If

                    Else

                        ' Index des Icons in der ImageList
                        lIconIndex = oIL.ListImages("Icon" & CStr(lIconIndex)).Index
                        
                        ' hat der Ordner das Attribut REPARSE_POINT
                        If (lAttr And FILE_ATTRIBUTE_REPARSE_POINT) = _
                            FILE_ATTRIBUTE_REPARSE_POINT Then

                            ' Index zu diesen Icon mit Overlayicon ermitteln
                            lIconIndex = oIL.ListImages("Icon_LINK" & _
                                CStr(lIconIndex)).Index

                        End If
                    End If
                End If

                ' Node hinzufgen
                Set xNode = .Add(, , sRootFolder, sRootFolder, lIconIndex, _
                    lIconIndex)

            Else

                ' Node ermitteln
                Set xNode = oTV.Nodes(sRootFolder)

            End If

            xNode.Sorted = True
            xNode.Selected = True

            ' alle Ordner, und deren Daten, in sRootFolder ermitteln
            lCount = EnumFolder(sRootFolder, flags, tFolders)

            ' hat sich die Anzahl der Ordner verndert?
            If Val(xNode.Tag) = lCount Then

                ' es hat sich nichts verndert, dann hier alles verlassen
                Set IImageList = Nothing
                Set FillTreeView = xNode
                Exit Function
            
            Else

                ' Anzahl der Ordner speichern
                xNode.Tag = CStr(lCount)

            End If

            oTV.MousePointer = ccHourglass

            ' neuzeichnen des TreeView unterbinden
            Call LockWindowUpdate(oTV.hwnd)

            ' alle Ordner durchlaufen
            For lItem = 0 To lCount - 1

                ' Attribute des Ordners ermitteln
                lAttr = GetFileAttributes(tFolders(lItem).ShellPath)

                ' wenn der Node noch nicht existiert
                If NodeExists(tFolders(lItem).ShellPath, oTV) = False Then

                    ' wenn das passenden Icon dazu noch nicht existiert
                    If IconExists("Icon" & CStr(tFolders(lItem).ShellIconIndex), _
                        oIL) = False Then

                        ' passendes Icon aus der SystemImageList holen
                        hIcon = IImageList.GetIcon(tFolders(lItem).ShellIconIndex, _
                            CLR_DEFAULT)

                        ' Icon der ImageList hinzufgen
                        Set xIcon = oIL.ListImages.Add(, "Icon" & CStr(tFolders( _
                            lItem).ShellIconIndex), Handle2IPicture(hIcon, _
                            vbPicTypeIcon))

                        ' Indes des Icons
                        lIconIndex = xIcon.Index

                        Call DestroyIcon(hIcon)

                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_LINK" & CStr(tFolders( _
                            lItem).ShellIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_LINK" & CStr( _
                                tFolders(lItem).ShellIconIndex), oIL.Overlay( _
                                "Icon" & CStr(tFolders(lItem).ShellIconIndex), _
                                "Overlay_LINK"))

                        End If

                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_SHARE" & CStr(tFolders( _
                            lItem).ShellIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_SHARE" & CStr( _
                                tFolders(lItem).ShellIconIndex), oIL.Overlay( _
                                "Icon" & CStr(tFolders(lItem).ShellIconIndex), _
                                "Overlay_SHARE"))

                        End If

                        ' wenn noch kein Icon mit Overlayicon existiert
                        If IconExists("Icon_SLOWFILE" & CStr(tFolders( _
                            lItem).ShellIconIndex), oIL) = False Then

                            ' nues Icon mit Overlayicon der ImageList hinzufgen
                            Set xIcon = oIL.ListImages.Add(, "Icon_SLOWFILE" & _
                                CStr(tFolders(lItem).ShellIconIndex), oIL.Overlay( _
                                "Icon" & CStr(tFolders(lItem).ShellIconIndex), _
                                "Overlay_SLOWFILE"))

                        End If

                        ' hat der Ordner das Attribut REPARSE_POINT
                        If (lAttr And FILE_ATTRIBUTE_REPARSE_POINT) = _
                            FILE_ATTRIBUTE_REPARSE_POINT Then

                            ' Index zu diesen Icon mit Overlayicon ermitteln
                            lIconIndex = oIL.ListImages("Icon_LINK" & CStr( _
                                tFolders(lItem).ShellIconIndex)).Index

                        End If

                    Else

                        
                        ' Index zu diesen Icon ermitteln
                        lIconIndex = oIL.ListImages("Icon" & CStr(tFolders( _
                            lItem).ShellIconIndex)).Index

                        ' hat der Ordner das Attribut REPARSE_POINT
                        If (lAttr And FILE_ATTRIBUTE_REPARSE_POINT) = _
                            FILE_ATTRIBUTE_REPARSE_POINT Then

                            ' Index zu diesen Icon mit Overlayicon ermitteln
                            lIconIndex = oIL.ListImages("Icon_LINK" & CStr( _
                                tFolders(lItem).ShellIconIndex)).Index

                        End If
                    End If

                    ' Node hinzufgen
                    Call .Add(sRootFolder, tvwChild, tFolders(lItem).ShellPath, _
                        tFolders(lItem).ShellName, lIconIndex, lIconIndex)

                End If

                ' hat dieser Ordner Unterordner?
                If FolderHasSubFolder(tFolders(lItem).ShellPath) = True Then

                    ' wenn noch kein Dummynode existiert
                    If NodeExists(tFolders(lItem).ShellPath & "\DummyNode", oTV) = _
                        False Then

                        ' Dummynode hinzufgen
                        Call .Add(tFolders(lItem).ShellPath, tvwChild, tFolders( _
                            lItem).ShellPath & "\DummyNode")

                    End If
                End If

                ' alle 50 durchlufe mal ein DoEvents
                If (lItem Mod 50) = 0 Then DoEvents

            Next lItem

        End With

        Call LockWindowUpdate(0&)
        oTV.MousePointer = ccDefault
        Set IImageList = Nothing

    End If

    Set FillTreeView = xNode

End Function

Private Function GetDriveType(ByVal sDrive As String) As Long

    GetDriveType = GetDriveTypeA(sDrive)

End Function

Private Function IconExists(ByVal sStr As String, ByVal oIL As ImageList) As Boolean

    Dim xIcon As ListImage

    On Error GoTo ErrorHandler

    Set xIcon = oIL.ListImages(sStr)

    IconExists = True

    Exit Function

ErrorHandler:

    IconExists = False

End Function

Private Function NodeExists(ByVal sStr As String, ByVal oTV As TreeView) As Boolean

    Dim xNode As Node

    On Error GoTo ErrorHandler

    Set xNode = oTV.Nodes(sStr)

    NodeExists = True

    Exit Function

ErrorHandler:

    NodeExists = False

End Function

Public Function EnumFolder(ByVal sRootFolder As String, ByVal flags As SHCONTF, _
    ByRef tFolders() As Folder) As Long

    Dim szName As String
    Dim szFullPath As String
    Dim lCount As Long
    Dim lPIDL As Long
    Dim lPIDL2 As Long
    Dim lPIDL3 As Long
    Dim plPIDL2 As Long
    Dim pszName As Long
    Dim pIShellIcon As Long
    Dim pIEnumIDList As Long
    Dim pIShellFolder2 As Long
    Dim pIShellFolderDesktop As Long
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim tSHELLDETAILS As SHELLDETAILS

    If Right$(sRootFolder, 1) <> "\" Then sRootFolder = sRootFolder & "\"

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolderDesktop) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolderDesktop As New clsIShellFolder
        Call IShellFolderDesktop.Initialize(pIShellFolderDesktop)
        Call IShellFolderDesktop.RaiseError(False)

        ' PIDL des Ordners ermitteln
        lPIDL = IShellFolderDesktop.ParseDisplayName(sRootFolder)

        If lPIDL <> 0 Then

            ' IShellFolder an IShellFolder2 binden
            pIShellFolder2 = IShellFolderDesktop.BindToObject(lPIDL, 0&, IID2Long( _
                IID_IShellFolder2))

            If pIShellFolder2 <> 0 Then

                ' IShellFolder2 initialisieren
                Dim IShellFolder2 As New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder2)
                Call IShellFolder2.RaiseError(False)

                ' IShellIcon-Interface vom IShellFolder2 erstellen
                pIShellIcon = IShellFolder2.QueryInterface(IID_IShellIcon)

                ' ist ein IShellIcon-Interface vorhanden
                If pIShellIcon <> 0 Then

                    ' IShellIcon initialisieren
                    Dim IShellIcon As New clsIShellIcon
                    Call IShellIcon.Initialize(pIShellIcon)
                    Call IShellIcon.RaiseError(False)

                    ' IEnumIDList abfragen
                    pIEnumIDList = IShellFolder2.EnumObjects(0&, flags)

                    If pIEnumIDList <> 0 Then

                        ' IEnumIDList initialisieren
                        Dim IEnumIDList As New clsIEnumIDList
                        Call IEnumIDList.Initialize(pIEnumIDList)
                        Call IEnumIDList.RaiseError(False)

                        plPIDL2 = VarPtr(lPIDL2)
                        ptSHELLDETAILS = VarPtr(tSHELLDETAILS)

                        ' alle Eintrge durchlaufen
                        Do While IEnumIDList.Fetch(1&, plPIDL2, 0&) = True

                            ' Name abfragen
                            If IShellFolder2.GetDetailsOf(lPIDL2, 0&, _
                                ptSHELLDETAILS) = True Then

                                ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)

                                ' Stringpointer von PIDL zu Stringpointer
                                If StrRetToStrA(ptSHELLDETAILS_str, lPIDL2, _
                                    pszName) = S_OK Then

                                    ' Stringpointer zu String
                                    szName = CutNull(SysAllocString(pszName))

                                    szName = Replace$(szName, Chr$(63), _
                                        vbNullString)

                                    ' Aufrumen
                                    Call CoTaskMemFree(pszName)

                                    If lCount = 0 Then

                                        ReDim tFolders(lCount)

                                    Else

                                        If lCount > UBound(tFolders) Then

                                            ReDim Preserve tFolders(UBound( _
                                                tFolders) + 100)

                                        End If

                                    End If

                                    ' absolute PIDL von lPIDL2 ermitteln
                                    lPIDL3 = ILCombine(lPIDL, lPIDL2)

                                    ' ist eine PIDL vorhanden
                                    If lPIDL3 <> 0 Then

                                        ' StringBuffer
                                        szFullPath = String$(MAX_PATH, 0)

                                        ' Pfad von PIDL ermitteln
                                        If SHGetPathFromIDList(lPIDL3, szFullPath) _
                                            = 1 Then

                                            szFullPath = CutNull(szFullPath)

                                        Else

                                            szFullPath = vbNullString

                                        End If

                                        ' Aufrumen
                                        Call CoTaskMemFree(lPIDL3)

                                    End If

                                    With tFolders(lCount)

                                        ' zB: "Benutzer"
                                        .ShellName = szName

                                        If Len(szFullPath) <> 0 Then

                                            ' zB: "C:\Users"
                                            .ShellPath = szFullPath

                                        Else

                                            ' zB: Inhalt vom Fonts-Folder
                                            .ShellPath = sRootFolder & szName

                                        End If

                                        ' Iconindex zur SystemImageList ermitteln
                                        .ShellIconIndex = IShellIcon.GetIconOf( _
                                            lPIDL2, GIL_FORSHELL)

                                    End With

                                End If
                            End If

                            lCount = lCount + 1
                            
                            ' alle 50 durchlufe mal ein DoEvents
                            If (lCount Mod 50) = 0 Then DoEvents

                            ' Aufrumen
                            Call CoTaskMemFree(lPIDL2)

                        Loop

                        ' Aufrumen
                        Set IEnumIDList = Nothing

                    End If

                    ' aufrumen
                    Set IShellIcon = Nothing

                End If

                ' Aufrumen
                Set IShellFolder2 = Nothing

            End If

            ' Aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        ' Aufrumen
        Set IShellFolderDesktop = Nothing

    End If

    ReDim Preserve tFolders(lCount)
    EnumFolder = lCount

End Function

Private Function GetIconIndex(ByVal sPath As String) As Long

    Dim lRet As Long
    Dim lPIDL As Long
    Dim pIShellIcon As Long
    Dim pIShellFolder As Long
    Dim pIExtractIcon As Long

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)
        Call IShellFolder.RaiseError(False)

        ' PIDL von Ordner ermitteln
        lPIDL = IShellFolder.ParseDisplayName(sPath)

        ' ist eine PIDL vorhanden
        If lPIDL <> 0 Then

            ' IShellIcon-Interface vom IShellFolder erstellen
            pIShellIcon = IShellFolder.QueryInterface(IID_IShellIcon)

            ' ist ein IShellIcon-Interface vorhanden
            If pIShellIcon <> 0 Then

                ' IShellIcon initialisieren
                Dim IShellIcon As New clsIShellIcon
                Call IShellIcon.Initialize(pIShellIcon)
                Call IShellIcon.RaiseError(False)

                ' Iconindex zur SystemImageList ermitteln
                lRet = IShellIcon.GetIconOf(lPIDL, GIL_FORSHELL)

                ' aufrumen
                Set IShellIcon = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        ' aufrumen
        Set IShellFolder = Nothing

    End If

    GetIconIndex = lRet

End Function

Public Function Handle2IPicture(ByVal hImage As Long, Optional ByVal handleType As _
    PictureTypeConstants = vbPicTypeBitmap) As IPicture

    Dim tPictDesc As PICTDESC
    Dim oPicture As IPicture

    With tPictDesc

        .cbSizeOfStruct = Len(tPictDesc)
        .picType = handleType
        .hgdiObj = hImage

    End With

    If OleCreatePictureIndirect(tPictDesc, IID2Long(IID_IPicture), True, oPicture) _
        = S_OK Then

        Set Handle2IPicture = oPicture

    End If

End Function

Private Function IID2Long(ByVal riid As String) As Long

    Dim triid(3) As Long
    Dim psriid As Long
    Dim ptriid As Long

    psriid = StrPtr(riid)
    ptriid = VarPtr(triid(0))

    Call IIDFromString(psriid, ptriid)

    IID2Long = ptriid

End Function

Private Function CutNull(ByVal sStr As String) As String

    Dim sRet As String

    If InStr(1, sStr, Chr$(0)) > 0 Then

        sRet = Mid$(sStr, 1, InStr(1, sStr, Chr$(0)) - 1)

    Else

        sRet = sStr

    End If

    CutNull = sRet

End Function

Private Function FolderHasSubFolder(ByVal sRootFolder As String) As Boolean

    Dim bRet As Boolean
    Dim hFile As Long
    Dim sFileName As String
    Dim sSearchFolder As String
    Dim pSearchFolder As Long
    Dim tWFD As WIN32_FIND_DATA

    If Right$(sRootFolder, 1) <> "\" Then sRootFolder = sRootFolder & "\"

    sSearchFolder = sRootFolder & "*"
    pSearchFolder = StrPtr(sSearchFolder)

    hFile = FindFirstFileExW(pSearchFolder, FindExInfoBasic, tWFD, _
        FindExSearchNameMatch, 0&, FIND_FIRST_EX_LARGE_FETCH)

    If hFile <> 0 Then

        Do

            sFileName = CutNull(StrConv(tWFD.cFileName, vbFromUnicode))

            If sFileName <> "." And sFileName <> ".." Then

                ' ein Ordner?
                If (tWFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = _
                    FILE_ATTRIBUTE_DIRECTORY Then

                    ' dann hier verlassen
                    bRet = True
                    Exit Do

                Else

                    ' bestimmte Dateitypen als Ordner?
                    Select Case LCase$(Right$(sFileName, 4))

                    Case ".ttf", ".tto", ".fon", ".zip", ".cab"
                        bRet = True
                        Exit Do
                    End Select

                    If LCase$(Right$(sFileName, Len(".search-ms"))) = _
                        ".search-ms" Then
                        bRet = True
                        Exit Do
                    End If

                    If LCase$(Right$(sFileName, Len(".searchconnector-ms"))) = _
                        ".searchconnector-ms" Then
                        bRet = True
                        Exit Do
                    End If
                End If
            End If

        Loop While FindNextFileW(hFile, tWFD)

        Call FindClose(hFile)

    Else

        bRet = False

    End If

    FolderHasSubFolder = bRet

End Function

